/*-
 * $Id: rr-profile.h,v 1.8 2002/05/11 17:54:01 jonas Exp $
 *
 * See the file LICENSE for redistribution information. 
 * If you have not received a copy of the license, please contact CodeFactory
 * by email at info@codefactory.se, or on the web at http://www.codefactory.se/
 * You may also write to: CodeFactory AB, SE-903 47, Ume, Sweden.
 *
 * Copyright (c) 2002 Jonas Borgstrm <jonas@codefactory.se>
 * Copyright (c) 2002 Daniel Lundin   <daniel@codefactory.se>
 * Copyright (c) 2002 CodeFactory AB.  All rights reserved.
 */

#ifndef __RR_PROFILE_H__
#define __RR_PROFILE_H__

typedef struct _RRProfile RRProfile;
typedef struct _RRProfileClass RRProfileClass;

#include <glib-object.h>
#include <librr/rr-channel.h>

G_BEGIN_DECLS

#define RR_TYPE_PROFILE (rr_profile_get_type ())
#define RR_PROFILE(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), RR_TYPE_PROFILE, RRProfile))
#define RR_PROFILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RR_TYPE_PROFILE, RRProfileClass))
#define RR_IS_PROFILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), RR_TYPE_PROFILE))
#define RR_IS_PROFILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RR_TYPE_PROFILE))
#define RR_PROFILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RR_TYPE_PROFILE, RRProfileClass))

#define RR_PROFILE_GTYPE_KEY_URI "RR_PROFILE_URI"

struct _RRProfile {
	RRChannel parent_object;
	gchar *piggyback;
};

struct _RRProfileClass {
	RRChannelClass parent_class;
	gboolean (* validate_piggyback) (RRProfile *profile, 
					 const gchar *piggyback,
					 gchar **reply);
	void (* reply_piggyback) (RRProfile *profile, 
				  const gchar *piggyback);
};

GType rr_profile_get_type (void);

const gchar *rr_profile_get_uri (GType type);
void rr_profile_set_uri (GType type, const gchar *uri);

gboolean rr_profile_validate_piggyback (RRProfile *profile, 
					const gchar *piggyback,
					gchar **reply);

void rr_profile_reply_piggyback (RRProfile *profile, 
				 const gchar *piggyback);

gchar *rr_profile_get_piggyback (RRProfile *profile);
void rr_profile_set_piggyback (RRProfile *profile, const gchar *piggyback);

G_END_DECLS

#endif /* __RR_PROFILE_H__ */


