/****************************************************************************/
/****************************************************************************/
/** \file memory.h
    \brief Header for 'safe' memory stuff, e.g. wrappers for malloc

*/
/****************************************************************************/

#include <string.h>
#include <stdlib.h>

void *calloc_safe(size_t nmemb, size_t size);
void *malloc_safe(size_t size);
void free_safe(void *ptr);
void *realloc_safe(void *ptr, size_t size);
char *strdup_safe(const char *s);
int cleanup_memory(void);
