/****************************************************************************/
/****************************************************************************/
/** \file naming.c
    \brief Code for mapping between protocol name and number

*/
/****************************************************************************/

#include "memory.h"
#include "types.h"

char **names=(char**)0;
PROTO *nums=(PROTO*)0;
unsigned long proto_count=0;
unsigned long space=0;

PROTO mapProtoNameToNum(char *name){
  unsigned long l;
  if(!name) return 0;
  for(l=0;l<proto_count;l++){
    if(!strcmp(name, names[l])) return nums[l];
  }
  return 0;
}

char *mapProtoNumToName(PROTO num){
  unsigned long l;
  if(!num) return 0;
  for(l=0;l<proto_count;l++){
    if(num == nums[l]) return strdup_safe(names[l]);
  }
  return (char*)0;
}

int storeProtoMapping(char *name, PROTO num){
  unsigned long l;

  if(!name) return 0;

  for(l=0;l<proto_count;l++){
    if(nums[l]==num){
      if(name && names[l]){
	if(!strcmp(name, names[l])) return 0;
      }
    }
  }

  if(space<=proto_count){
    space += 100;
    nums = realloc_safe(nums, sizeof(PROTO)*space);
    names = realloc_safe(names, sizeof(char*)*space);
  }
  
  if(!nums || !names) return 0;

  nums[proto_count] = num;
  names[proto_count]= strdup_safe(name);
  proto_count++;

  return 1;
}

void cleanMapping(void){
  unsigned long l;
  for(l=0;l<proto_count;l++){
    free_safe(names[proto_count]);
  }
  free_safe(names);
  names = (char **)0;
  free_safe(nums);
  nums = (PROTO*)0;
  space = 0;
  proto_count = 0;
}
