/****************************************************************************/
/****************************************************************************/
/** \file policy-build.h
    \brief Header for building policies.

*/
/****************************************************************************/

#include "policy.h"

#ifndef POLICY_BUILD_H
#define POLICY_BUILD_H

POLICY_HEAD *newPolicy(void);

/* processing rules */
POLICY_TEST *createBlankTest(void);
POLICY_TEST *createAnalysisTest(char*,char*,char*,PROTO);
POLICY_TEST *createDefaultTest(void);
POLICY_TEST *attachTestToResult(POLICY_RESULT*,POLICY_TEST*);
POLICY_TEST *attachTestToProto(POLICY_PROTO*,POLICY_TEST*);
POLICY_TEST *attachTestToOutput(POLICY_OUTPUT*,POLICY_TEST*);
POLICY_TEST *attachTestToPolicy(POLICY_HEAD*,POLICY_TEST*);

POLICY_PROTO *addProtoToPolicy(POLICY_HEAD*,PROTO,char*);

POLICY_RESULT *addResultToTest(POLICY_TEST*,char*,unsigned short);

POLICY_OUTPUT *addOutputToResult(POLICY_RESULT*,char*,char*,char);
POLICY_OUTPUT *addOutputToOutput(POLICY_OUTPUT*,char*,char*,char);

/* input rules */
POLICY_HEAD *addInputToPolicy(POLICY_HEAD*,char*,unsigned short,char*,int);

/* inits */
POLICY_HEAD *addInitToPolicy(POLICY_HEAD*,char*,char*);

#endif /* POLICY_BUILD_H */
