/****************************************************************************/
/****************************************************************************/
/** \file policy-xml.h
    \brief Header for building policy from xml rules

*/
/****************************************************************************/

#include "policy.h"
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>

#ifndef POLICY_XML_H
#define POLICY_XML_H

typedef struct DEFINE_LL_S {
  char *id;
  xmlDocPtr doc;
  xmlNodePtr node;
  struct DEFINE_LL_S *next;
} DEFINE_LL;

int buildXmlSnort(xmlDocPtr, xmlNodePtr, POLICY_HEAD*, POLICY_OUTPUT*);

int buildXmlDefault(xmlDocPtr, xmlNodePtr, POLICY_HEAD*);

int buildXmlOutput(xmlDocPtr, xmlNodePtr, POLICY_OUTPUT*);

int buildXmlDefine(xmlDocPtr, xmlNodePtr);

int buildXmlProtocol(xmlDocPtr, xmlNodePtr, POLICY_HEAD*, POLICY_OUTPUT*);

int buildXmlAnalysis(xmlDocPtr, xmlNodePtr, POLICY_OUTPUT*);

int buildXmlInstance(xmlDocPtr, xmlNodePtr, POLICY_HEAD*, POLICY_OUTPUT*);

int buildXmlAnalysisResult(xmlDocPtr, xmlNodePtr, POLICY_TEST*);

POLICY_HEAD *buildXmlPolicy(char *, unsigned long);

POLICY_HEAD *buildXmlPolicyFromFile(char*);

int buildXmlInit(xmlDocPtr, xmlNodePtr, POLICY_HEAD*);

int buildXmlInput(xmlDocPtr, xmlNodePtr, POLICY_HEAD*);

#endif /* POLICY_XML_H */
