/*****************************************************************************/
/*****************************************************************************/
/** \file protocols.h
    \brief Protocol names and numbers.

    This file contains defines for all the protocol names and numbers currently
    supported. Note that a protocol doesn't have to be in this list to be
    supported, as long as it has a unique name and number there's no problem.
*/
/*****************************************************************************/

#define  PROTO_ETH_NAME     "ETH"
#define  PROTO_ETH_NUM      0x00000001
#define  PROTO_IP_NAME      "IP"
#define  PROTO_IP_NUM       0x00000002
#define  PROTO_ICMP_NAME    "ICMP"
#define  PROTO_ICMP_NUM     0x00000003
#define  PROTO_TCP_NAME     "TCP"
#define  PROTO_TCP_NUM      0x00000004
#define  PROTO_UDP_NAME     "UDP"
#define  PROTO_UDP_NUM      0x00000005
#define  PROTO_IPV6_NAME    "IPV6"
#define  PROTO_IPV6_NUM     0x00000006
#define  PROTO_ICMPV6_NAME  "ICMPV6"
#define  PROTO_ICMPV6_NUM   0x00000007
#define  PROTO_IPX_NAME     "IPX"
#define  PROTO_IPX_NUM      0x00000008
#define  PROTO_SLIP_NAME    "SLIP"
#define  PROTO_SLIP_NUM     0x00000009
#define  PROTO_PPP_NAME     "PPP"
#define  PROTO_PPP_NUM      0x0000000A
#define  PROTO_IGMP_NAME    "IGMP"
#define  PROTO_IGMP_NUM     0x0000000B
#define  PROTO_GGP_NAME     "GGP"
#define  PROTO_GGP_NUM      0x0000000C
#define  PROTO_EGP_NAME     "EGP"
#define  PROTO_EGP_NUM      0x0000000D
#define  PROTO_IGRP_NAME    "IGRP"
#define  PROTO_IGRP_NUM     0x0000000E
#define  PROTO_PUP_NAME     "PUP"
#define  PROTO_PUP_NUM      0x0000000F
#define  PROTO_IDP_NAME     "IDP"
#define  PROTO_IDP_NUM      0x00000010
#define  PROTO_RSVP_NAME    "RSVP"
#define  PROTO_RSVP_NUM     0x00000011
#define  PROTO_VINES_NAME   "VINES"
#define  PROTO_VINES_NUM    0x00000012
#define  PROTO_ANY_NAME     "ANY"
#define  PROTO_ANY_NUM      0xFFFFFFFF

