/****************************************************************************/
/****************************************************************************/
/** \file protoplug.h
    \brief Header for Protocol plugins

*/
/****************************************************************************/

#include "policy.h"
#include "plugin.h"
#include "packet.h"
#include "types.h"

#ifndef PROTOPLUG_H
#define PROTOPLUG_H

int pluginRegister(INPLUG **, ANPLUG **, PROTOPLUG **, OUTPLUG **,
		   int(*DecodeCallback)(PACKET*,PROTO));
int pluginInit(int ct, char **inits);
int pluginCleanup(int reason);

int pluginDecode(PACKET *, PROTO protocol);
int pluginTest(PACKET *, char *, char *);
int pluginPrint(PACKET *, char *args,
		int(*print)(char *fmt, ...));
int pluginMkTest(PROTO, char*, char*, char *, POLICY_TEST *);

#endif /* PROTOPLUG_H */

